c     La taille maximum des matrices est contenue dans le
c     parametre MAX




c     **************************************************
c	action : LECT_COMMENTAIRE()
c	Donnes / Rsultats :  
c	Rsultats : 
c          Locales : TMP chaine de caractere
c     Description : lecture de la ligne de commentaire
c     **************************************************

      SUBROUTINE LECT_COMMENTAIRE()
      implicit none
      character *1024 TMP
      
      read *,TMP
	
        return
      end subroutine LECT_COMMENTAIRE



c     **************************************************
c	action : LECT_TAILLE(N ,NBELEM)
c	Donnes :  /
c	Donnes / Rsultats :  
c	Rsultats : N entier : entier lu, 
c         NBELEM entier : entier lu nombre d lments de la matrice
c	Locales : 
c	Description : lecture de la taille de la matrice et 
c         de son nombre d lment
c     **************************************************
      SUBROUTINE LECT_TAILLE(N,NBELEM)
      implicit none
      integer N,TMP,NBELEM
c      print *,'Taille de la matrice'
      read *,N ,TMP, NBELEM
	if (N.lt.0) then
	 print *,'Erreur la dimension doit etre positive !'
	 stop
	endif
	if (NBELEM.le.0) then
	 print *,'Erreur la matrice est vide !'
	 stop
	endif
        return
      end subroutine LECT_TAILLE





c     **************************************************
c	action : INIT_MATRIX(N,A)
c	Donnes :  N entier : taille de la matrice carre
c	Donnes / Rsultats :  
c	Rsultats : A(N,N) rel : matrice carre de taille N 
c	Locales : ligne, colonne : entier
c	Description : On initialise  0 la matrice colonne par colonne
c     **************************************************
      SUBROUTINE INIT_MATRIX(N,A)
      implicit none
      integer N,ligne,colonne
      REAL*8 A(N,N) 
      
      DO colonne=1,N
         DO ligne=1,N
		A(ligne,colonne)=0.0
	 END DO
      END DO
        
      return
      end subroutine INIT_MATRIX


c     **************************************************
c	action : LECT_MATRIX(N,NBELEM,A)
c	Donnes :  N : entier taille de la matrice carre, NBELEM entier : 
c	nombre d'elements de la matrice
c	Donnes / Rsultats :  
c	Rsultats : A(N,N) rel : matrice carre de taille N lue
c	Locales : i,ligne, colonne : entier
c	Description : On lit les NBELEM de la matrice . 
c       chaque lments est compos de la manire suivante ligne, 
c       colonne puis la valeur de A  ces coordonnes
c     **************************************************
      SUBROUTINE LECT_MATRIX(N,NBELEM,A)
      implicit none
      integer N,NBELEM,i,ligne,colonne
      REAL*8 A(N,N) 
      
      DO i=1,NBELEM
		READ *, ligne,colonne,A(ligne,colonne)
      END DO
        
      return
      end subroutine LECT_MATRIX






c     **************************************************
c	action : LECT_VECTEUR(N,B)
c	Donnes :  N entier : taille du vecteur
c	Donnes / Rsultats :  
c	Rsultats : B(N) rel : vecteur de taille N lu
c	Locales : ligne : entier
c	Description : saisie d un vecteur de taille N
c     **************************************************

      SUBROUTINE LECT_VECTEUR(N,B)
      implicit none
      integer N,ligne
      REAL*8 B(N) 
      DO ligne=1,N
c      print *,ligne
         READ *,B(ligne)
      END DO
      return
      end subroutine LECT_VECTEUR
      


c     **************************************************
c	action : COMPLETE_MATRIX(N,A)
c	Donnes :  N entier : taille de la matrice carre
c	Donnes / Rsultats :  A(N,N) rel : matrice carre de taille N lue
c	Rsultats : 
c	Locales : ligne, colonne : entier
c	Description : On complte la matrice triangulaire infrieure par son 
c       symtrique
c     **************************************************
      SUBROUTINE COMPLETE_MATRIX(N,A)
      implicit none
      integer N,ligne,colonne
      REAL*8 A(N,N) 
      DO ligne=1,N
         DO colonne=1,ligne-1
           A(colonne,ligne)= A(ligne,colonne)
	 END DO
      END DO
      RETURN
      end subroutine COMPLETE_MATRIX



c     **************************************************
c	action : AFFICHE_MATRIX(N,A)
c	Donnes :  N entier : taille de la matrice carre, A(N,N) rel : 
c	matrice carre de taille N lue
c	Donnes / Rsultats :  
c	Rsultats : 
c	Locales : ligne, colonne : entier
c	Description : on affiche la matrice complte colonne par colonne, 
c       ligne par ligne
c	On ne peut pas afficher le tout sur une ligne donc on met l indice 
c	devant le rsultat
c     **************************************************

      SUBROUTINE AFFICHE_MATRIX(N,A)
      implicit none
      integer N,ligne,colonne
      REAL*8 A(N,N)

      DO ligne=1,N
         DO colonne=1,N
	   PRINT *,'*    (',ligne,',',colonne,') = ', A(ligne,colonne)
	 END DO

      END DO
      RETURN
      end subroutine AFFICHE_MATRIX


c     **************************************************
c	action : AFFICHE_VECTEUR(N,X)
c	Donnes :  N entier : taille de la matrice carre, X(N) rel : 
c	vecteur de taille N 
c	Donnes / Rsultats :  
c	Rsultats : 
c	Locales : ligne : entier
c	Description : on affiche le vecteur ligne par ligne
c     **************************************************

      SUBROUTINE AFFICHE_VECTEUR(N,X)
      implicit none
      integer N,ligne
      REAL*8 X(N)

      DO ligne=1,N
         PRINT *,'*    (',ligne,') = ', X(ligne)
      END DO
      RETURN
      end subroutine AFFICHE_VECTEUR



c     **************************************************
c	action : CALCUL_DE_L(A,N,L)
c	Donnes :  N entier : taille de la matrice carre, A(N,N) rel : 
c	matrice carre de taille N 
c	Donnes / Rsultats :  
c	Rsultats : L(N,N) rel : matrice carre de taille N 
c	Locales : I,J,K : entier, SOMME : rel
c	Description : on calcule la matrice l par la dcomposition de cholesky
c     **************************************************

	SUBROUTINE CALCUL_DE_L(A,N,L)
	IMPLICIT NONE
	INTEGER I,J,K,N
	REAL *8 A(N,N),L(N,N),SOMME

c	calcul du premier lement de L
        L(1,1)=SQRT(A(1,1))

c	calcul du reste de la 1re colonne
	  DO I=2,N
		L(I,1)=A(I,1)/L(1,1)
	  ENDDO

c	On dtermine la ime colonne de L, aprs avoir calcul les (i-1) 
c       premires colonnes 
	  DO J=2,N
		DO I=2,N
			IF(I.lt.J) THEN
				L(I,J)=0.
			ELSEIF(I.eq.J) THEN
				SOMME=0.
				DO K=1,I-1
					SOMME=SOMME+L(I,K)**2.
                                ENDDO
                                IF ((A(I,I)-SOMME).LE.0.0) THEN
         print *,'Erreur la matrice doit etre definie positive !'
                                 
                                 STOP


                                ENDIF



                                L(I,I)=SQRT(A(I,I)-SOMME)
	                ELSE
				SOMME=0.
				DO K=1,J-1
					SOMME=SOMME+L(I,K)*L(J,K)
				ENDDO
				L(I,J)=(A(I,J)-SOMME)/L(J,J)
		      ENDIF
		ENDDO
	 ENDDO
         RETURN
	END SUBROUTINE CALCUL_DE_L




c     **************************************************
c	action : CALCUL_DE_Y(L,B,N,Y)
c	Donnes :  N entier : taille de la matrice carre, 
c         L(N,N) rel : matrice carre de taille N , 
c         B(N) rel : vecteur de taille N
c	Donnes / Rsultats :  
c	Rsultats : Y(N) rel : vecteur de taille N 
c	Locales : I,J : entier, SOMME : rel
c	Description : on calcule le vecteur Y par la dcomposition 
c       de cholesky LY=B
c     **************************************************

	SUBROUTINE CALCUL_DE_Y(L,B,N,Y)
	IMPLICIT NONE
	INTEGER I,J,N
	REAL *8 B(N),Y(N),L(N,N),SOMME

	  DO I=1,N
		SOMME=0.
		DO J=1,I-1
			SOMME=SOMME+Y(J)*L(I,J)
		ENDDO
		Y(I)=(B(I)-SOMME)/L(I,I)
          ENDDO
          RETURN
	END SUBROUTINE CALCUL_DE_Y





c     **************************************************
c	action : CALCUL_DE_X(L,Y,N,X)
c	Donnes :  N entier : taille de la matrice carre, 
c         L(N,N) rel : matrice carre de taille N, 
c         Y(N) rel : vecteur de taille N
c	Donnes / Rsultats :  
c	Rsultats : X(N) rel : vecteur de taille N 
c	Locales : I,J : entier, SOMME : rel
c	Description : on calcule le vecteur X par la dcomposition de 
c       cholesky Lt.X=Y
c	Le vecteur X est donc la solution du systme
c     **************************************************

	SUBROUTINE CALCUL_DE_X(L,Y,N,X)
	IMPLICIT NONE
	INTEGER I,J,N
	REAL *8 Y(N),X(N),L(N,N),SOMME

	  DO I=N,1,-1
		SOMME=0.
		DO J=I+1,N
			SOMME=SOMME+X(J)*L(J,I)
		ENDDO
		X(I)=(Y(I)-SOMME)/L(I,I)
          ENDDO
          RETURN
	END SUBROUTINE CALCUL_DE_X





c     **************************************************
c	action : CALCUL_DET(L,N,DET)
c	Donnes :  N entier : taille de la matrice carre, 
c         L(N,N) rel : matrice carre de taille N, 
c	Donnes / Rsultats :  
c	Rsultats : DET rel : determinant du systeme 
c	Locales : I : entier
c	Description : On calcule le determinant de la  
c       Matrice A. Il s'agit du carr du produit des
c	elements de la diagonale de L
c       La matrice L est calcule dans la factorisation
c     **************************************************

	SUBROUTINE CALCUL_DET(L,N,DET)
        IMPLICIT NONE
        INTEGER I,N
        REAL *8 L(N,N),DET
 
        DET = 1.

        DO I=1,N
           DET=DET*L(I,I)
        ENDDO
        DET=DET**2
        RETURN
        END SUBROUTINE CALCUL_DET
        






c     **************************************************
c	programme principal
c	Appelle les differentes procedures du programme	
c     **************************************************
	program cholesky
	implicit none
        INTEGER N,NBELEM,MAX
        INTEGER  TICK
        REAL*8  CPT_START,CPT_STOP
        REAL*8 TPS_CALCUL_TOTAL,TPS_CALCUL_L,TPS_CALCUL_Y,TPS_CALCUL_X

        PARAMETER (MAX=1500)

        REAL*8 A(MAX,MAX),L(MAX,MAX),B(MAX),Y(MAX),X(MAX),DET
        

      
c        call LECT_COMMENTAIRE()




	  call LECT_TAILLE(N,NBELEM)
        call INIT_MATRIX(N,A)

        call LECT_MATRIX(N,NBELEM,A)

        call COMPLETE_MATRIX(N,A)

        PRINT *,' AFFICHAGE DE A : '
        call AFFICHE_MATRIX(N,A)
        call LECT_VECTEUR(N,B)
        PRINT *,' '

        PRINT *,' AFFICHAGE DE B'
        call AFFICHE_VECTEUR(N,B)
        PRINT *,' '


        
        call cpu_time(CPT_START)
        call CALCUL_DE_L(A,N,L)
        call cpu_time(CPT_STOP)
        TPS_CALCUL_L=(CPT_STOP-CPT_START)
        

        PRINT *,' '
        PRINT *,' AFFICHAGE DE L : '
        call AFFICHE_MATRIX(N,L)

       
        call cpu_time(CPT_START)
        call CALCUL_DE_Y(L,B,N,Y)
        call cpu_time(CPT_STOP)
        TPS_CALCUL_Y=(CPT_STOP-CPT_START)

 
        PRINT *,' AFFICHAGE DE Y'
        call AFFICHE_VECTEUR(N,Y)

       
        call cpu_time(CPT_START)
        call CALCUL_DE_X(L,Y,N,X)
        call cpu_time(CPT_STOP)
        TPS_CALCUL_X=(CPT_STOP-CPT_START)
   

        PRINT *,' AFFICHAGE DU RESULTAT X '
        call AFFICHE_VECTEUR(N,X)



        PRINT *,' '
        call CALCUL_DET(L,N,DET)
        PRINT *, ' LE DETERMINANT DE A EST : ', DET


        PRINT *,' '
        PRINT *, 'TPS DE CALCUL DE L : ',TPS_CALCUL_L, ' s'
        PRINT *, 'TPS DE CALCUL DE Y : ',TPS_CALCUL_Y, ' s'
        PRINT *, 'TPS DE CALCUL DE X : ',TPS_CALCUL_X, ' s'

        TPS_CALCUL_TOTAL=TPS_CALCUL_L+TPS_CALCUL_Y+TPS_CALCUL_X
        PRINT *,'LE TEMPS DE CALCUL TOTAL EST DE : '
        PRINT *, TPS_CALCUL_TOTAL,' s'

	end program cholesky
